To create a button cell, follow this example:
You can customize your Button using the many provided APIs. If you want to control the button's position in the cell, use the following methods.
marginTop: Gets or sets the button's top margin in pixels relative to the cell.
marginRight: Gets or sets the button's right margin in pixels relative to the cell.
marginBottom: Gets or sets the button's bottom margin in pixels relative to the cell.
marginLeft: Gets or sets the button's left margin in pixels relative to the cell.
You can use the text method to get and set the button's content. Use the buttonBackColor method to get and set the button's background color. For example:
window.onload = function () {
var spread = new GC.Spread.Sheets.Workbook(document.getElementById("ss"));
initSpread(spread);
};
function initSpread(spread) {
var spreadNS = GC.Spread.Sheets;
var sheet = spread.getSheet(0);
sheet.bind(spreadNS.Events.SelectionChanged, function () {
propertyChange(false);
});
sheet.suspendPaint();
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
var b0 = new spreadNS.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, spreadNS.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
sheet.resumePaint();
_getElementById("changeProperty").addEventListener('click',function () {
propertyChange(true);
});
function propertyChange(isSet) {
var sheet = spread.getActiveSheet();
var sels = sheet.getSelections();
if (sels && sels.length > 0) {
var sel = getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
var buttonCellType = sheet.getCellType(sel.row, sel.col);
if (!(buttonCellType instanceof spreadNS.CellTypes.Button)) {
_getElementById("changeProperty").setAttribute("disabled",'disabled');
return;
}
if (!isSet) {
_getElementById("changeProperty").removeAttribute("disabled");
_getElementById("txtButtonCellMarginLeft").value=buttonCellType.marginLeft();
_getElementById("txtButtonCellMarginTop").value=buttonCellType.marginTop();
_getElementById("txtButtonCellMarginRight").value=buttonCellType.marginRight();
_getElementById("txtButtonCellMarginBottom").value=buttonCellType.marginBottom();
_getElementById("txtButtonCellText").value=buttonCellType.text();
_getElementById("txtButtonCellBackColor").value=buttonCellType.buttonBackColor();
} else {
buttonCellType.marginLeft(parseInt(_getElementById("txtButtonCellMarginLeft").value));
buttonCellType.marginTop(parseInt(_getElementById("txtButtonCellMarginTop").value));
buttonCellType.marginRight(parseInt(_getElementById("txtButtonCellMarginRight").value));
buttonCellType.marginBottom(parseInt(_getElementById("txtButtonCellMarginBottom").value));
buttonCellType.text(_getElementById("txtButtonCellText").value);
buttonCellType.buttonBackColor(_getElementById("txtButtonCellBackColor").value);
}
}
sheet.repaint();
}
function getActualRange(range, maxRowCount, maxColCount) {
var row = range.row < 0 ? 0 : range.row;
var col = range.col < 0 ? 0 : range.col;
var rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
var colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
}
}
function _getElementById(id){
return document.getElementById(id);
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/purejs/node_modules/@grapecity/spread-sheets/dist/gc.spread.sheets.all.min.js" type="text/javascript"></script>
<script src="$DEMOROOT$/spread/source/js/license.js" type="text/javascript"></script>
<script src="app.js" type="text/javascript"></script>
<link rel="stylesheet" type="text/css" href="styles.css">
</head>
<body>
<div class="sample-tutorial">
<div id="ss" class="sample-spreadsheets"></div>
<div class="options-container">
<label>Select the button cell in Spread and edit its options with these text boxes.</label>
<div class="option-row">
<label>margin-left:</label>
<input type="text" id="txtButtonCellMarginLeft" />
<label>margin-top:</label>
<input type="text" id="txtButtonCellMarginTop" />
</div>
<div class="option-row">
<label>margin-right:</label>
<input type="text" id="txtButtonCellMarginRight" />
<label>margin-bottom:</label>
<input type="text" id="txtButtonCellMarginBottom" />
</div>
<div class="option-row">
<label>text:</label>
<input type="text" id="txtButtonCellText" />
<label>backColor:</label>
<input type="text" id="txtButtonCellBackColor" />
</div>
<div class="option-row">
<label></label>
<input type="button" id="changeProperty" value="Update"/>
</div>
</div>
</div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.option-row {
padding-bottom: 8px;
}
label {
padding-bottom: 4px;
display: block;
}
input {
width: 100%;
padding: 4px 8px;
box-sizing: border-box;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}

To create a button cell, follow this example:
You can customize your Button using the many provided APIs. If you want to control the button's position in the cell, use the following methods.
marginTop: Gets or sets the button's top margin in pixels relative to the cell.
marginRight: Gets or sets the button's right margin in pixels relative to the cell.
marginBottom: Gets or sets the button's bottom margin in pixels relative to the cell.
marginLeft: Gets or sets the button's left margin in pixels relative to the cell.
You can use the text method to get and set the button's content. Use the buttonBackColor method to get and set the button's background color. For example:
import * as React from 'react';
import { createRoot } from 'react-dom/client';
import './styles.css';
import { AppFunc } from './app-func';
// import { App } from './app-class';
// 1. Functional Component sample
createRoot(document.getElementById('app')).render(<AppFunc />);
// 2. Class Component sample
// createRoot(document.getElementById('app')).render(<App />);
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const spreadNS = GC.Spread.Sheets;
let sheet = null;
export function AppFunc() {
const [buttonCellTypeOption, setButtonCellTypeOption] = React.useState({
marginLeft: 0,
marginRight: 0,
marginTop: 0,
marginBottom: 0,
text: '',
buttonBackColor: '',
disabled: false
});
const initSpread = (spread) => {
sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
var b0 = new spreadNS.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, spreadNS.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
sheet.resumePaint();
sheet.bind(spreadNS.Events.SelectionChanged, () => {
updateProperty(null, false);
});
}
const updateProperty = (e, settings) => {
const sels = sheet.getSelections();
if (sels && sels.length > 0) {
const sel = getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
const buttonCellType = sheet.getCellType(sel.row, sel.col);
if (!(buttonCellType instanceof spreadNS.CellTypes.Button)) {
setButtonCellTypeOption({...buttonCellTypeOption, disabled: true});
return;
}
if (!settings) {
setButtonCellTypeOption({
disabled: false,
marginLeft: buttonCellType.marginLeft(),
marginRight: buttonCellType.marginRight(),
marginTop: buttonCellType.marginTop(),
marginBottom: buttonCellType.marginBottom(),
text: buttonCellType.text(),
buttonBackColor: buttonCellType.buttonBackColor()
});
} else {
buttonCellType.marginLeft(settings.marginLeft);
buttonCellType.marginTop(settings.marginTop);
buttonCellType.marginRight(settings.marginRight);
buttonCellType.marginBottom(settings.marginBottom);
buttonCellType.text(settings.text);
buttonCellType.buttonBackColor(settings.buttonBackColor);
}
}
sheet.repaint();
}
const getActualRange = (range, maxRowCount, maxColCount) => {
const row = range.row < 0 ? 0 : range.row;
const col = range.col < 0 ? 0 : range.col;
const rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
const colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
}
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={initSpread}>
<Worksheet />
</SpreadSheets>
</div>
<Panel updateProperty={updateProperty} setting={buttonCellTypeOption} />
</div>);
}
function Panel(props) {
const [setting, setSetting] = React.useState(props.setting);
React.useEffect(() => {
setSetting(props.setting);
}, [props.setting]);
return (
<div class="options-container">
<label>Select the button cell in Spread and edit its options with these text boxes.</label>
<div class="option-row">
<label for="txtButtonCellMarginLeft">margin-left:</label>
<input id="txtButtonCellMarginLeft" value={setting.marginLeft} onChange={(e) => { setSetting({ ...setting, marginLeft: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginTop">margin-top:</label>
<input id="txtButtonCellMarginTop" value={setting.marginTop} onChange={(e) => { setSetting({ ...setting, marginTop: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginRight">margin-right:</label>
<input id="txtButtonCellMarginRight" value={setting.marginRight} onChange={(e) => { setSetting({ ...setting, marginRight: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginBottom">margin-bottom:</label>
<input id="txtButtonCellMarginBottom" value={setting.marginBottom} onChange={(e) => { setSetting({ ...setting, marginBottom: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellText">text:</label>
<input id="txtButtonCellText" value={setting.text} onChange={(e) => { setSetting({ ...setting, text: e.target.value }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellBackColor">backColor:</label>
<input id="txtButtonCellBackColor" value={setting.buttonBackColor} onChange={(e) => { setSetting({ ...setting, buttonBackColor: e.target.value }); }}/>
</div>
<div class="option-row">
<input type="button" id="setProperty" value="Update Properties" disabled={setting.disabled} onClick={(e) => {props.updateProperty(e, setting)} } />
</div>
</div>
);
}
import * as React from 'react';
import GC from '@mescius/spread-sheets';
import { SpreadSheets, Worksheet } from '@mescius/spread-sheets-react';
const spreadNS = GC.Spread.Sheets;
const Component = React.Component;
export class App extends Component {
constructor(props) {
super(props);
this.sheet = null;
this.state = {
marginLeft: 0,
marginRight: 0,
marginTop: 0,
marginBottom: 0,
text: '',
buttonBackColor: '',
disabled: false
}
}
render() {
return (<div class="sample-tutorial">
<div class="sample-spreadsheets">
<SpreadSheets workbookInitialized={spread => this.initSpread(spread)}>
<Worksheet />
</SpreadSheets>
</div>
<Panel updateProperty={(e, settings) => {this.updateProperty(e, settings)}} setting={this.state} />
</div>);
}
initSpread(spread) {
const sheet = spread.getSheet(0);
this.sheet = sheet;
sheet.suspendPaint();
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
var b0 = new spreadNS.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, spreadNS.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
sheet.resumePaint();
sheet.bind(spreadNS.Events.SelectionChanged, () => {
this.updateProperty(null, false);
});
}
updateProperty(e, settings) {
const sheet = this.sheet;
const sels = sheet.getSelections();
if (sels && sels.length > 0) {
const sel = this.getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
const buttonCellType = sheet.getCellType(sel.row, sel.col);
if (!(buttonCellType instanceof spreadNS.CellTypes.Button)) {
this.disabled = true;
return;
}
if (!settings) {
this.setState({
disabled: false,
marginLeft: buttonCellType.marginLeft(),
marginRight: buttonCellType.marginRight(),
marginTop: buttonCellType.marginTop(),
marginBottom: buttonCellType.marginBottom(),
text: buttonCellType.text(),
buttonBackColor: buttonCellType.buttonBackColor()
})
} else {
buttonCellType.marginLeft(settings.marginLeft);
buttonCellType.marginTop(settings.marginTop);
buttonCellType.marginRight(settings.marginRight);
buttonCellType.marginBottom(settings.marginBottom);
buttonCellType.text(settings.text);
buttonCellType.buttonBackColor(settings.buttonBackColor);
}
}
sheet.repaint();
}
getActualRange(range, maxRowCount, maxColCount) {
const row = range.row < 0 ? 0 : range.row;
const col = range.col < 0 ? 0 : range.col;
const rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
const colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
}
}
class Panel extends Component {
constructor(props) {
super(props);
this.state = this.props.setting;
}
componentWillReceiveProps(nextProps) {
this.setState(nextProps.setting);
}
render() {
return (
<div class="options-container">
<label>Select the button cell in Spread and edit its options with these text boxes.</label>
<div class="option-row">
<label for="txtButtonCellMarginLeft">margin-left:</label>
<input id="txtButtonCellMarginLeft" value={this.state.marginLeft} onChange={(e) => { this.setState({ marginLeft: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginTop">margin-top:</label>
<input id="txtButtonCellMarginTop" value={this.state.marginTop} onChange={(e) => { this.setState({ marginTop: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginRight">margin-right:</label>
<input id="txtButtonCellMarginRight" value={this.state.marginRight} onChange={(e) => { this.setState({ marginRight: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginBottom">margin-bottom:</label>
<input id="txtButtonCellMarginBottom" value={this.state.marginBottom} onChange={(e) => { this.setState({ marginBottom: Number(e.target.value) }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellText">text:</label>
<input id="txtButtonCellText" value={this.state.text} onChange={(e) => { this.setState({ text: e.target.value }); }}/>
</div>
<div class="option-row">
<label for="txtButtonCellBackColor">backColor:</label>
<input id="txtButtonCellBackColor" value={this.state.buttonBackColor} onChange={(e) => { this.setState({ buttonBackColor: e.target.value }); }}/>
</div>
<div class="option-row">
<input type="button" id="setProperty" value="Update Properties" disabled={this.state.disabled} onClick={(e) => {this.props.updateProperty(e, this.state)} } />
</div>
</div>
)
}
}
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/react/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- SystemJS -->
<script src="$DEMOROOT$/en/react/node_modules/systemjs/dist/system.src.js"></script>
<script src="systemjs.config.js"></script>
<script>
System.import('$DEMOROOT$/en/lib/react/license.js').then(function () {
System.import('./src/app');
});
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.sample-options{
z-index: 1000;
}
.option {
padding-bottom: 6px;
}
.checkbox {
padding-right: 12px;
display: inline-block;
}
label {
display: inline-block;
min-width: 100px;
}
input, select {
width: 100%;
padding: 4px 0;
margin-top: 4px;
box-sizing: border-box;
}
input[type=checkbox] {
width: auto;
padding: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
#app {
height: 100%;
}
(function (global) {
System.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true,
react: true
},
meta: {
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-react': 'cdn:@mescius/spread-sheets-react/index.js',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js',
'react': 'npm:react/cjs/react.production.js',
'react-dom': 'npm:react-dom/cjs/react-dom.production.js',
'react-dom/client': 'npm:react-dom/cjs/react-dom-client.production.js',
'scheduler': 'npm:scheduler/cjs/scheduler.production.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'jsx'
},
"node_modules": {
defaultExtension: 'js'
},
}
});
})(this);

To create a button cell, follow this example:
You can customize your Button using the many provided APIs. If you want to control the button's position in the cell, use the following methods.
marginTop: Gets or sets the button's top margin in pixels relative to the cell.
marginRight: Gets or sets the button's right margin in pixels relative to the cell.
marginBottom: Gets or sets the button's bottom margin in pixels relative to the cell.
marginLeft: Gets or sets the button's left margin in pixels relative to the cell.
You can use the text method to get and set the button's content. Use the buttonBackColor method to get and set the button's background color. For example:
<template>
<div class="sample-tutorial">
<gc-spread-sheets class="sample-spreadsheets" @workbookInitialized="initSpread">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<label>Select the button cell in Spread and edit its options with these text boxes.</label>
<div class="option-row">
<label for="txtButtonCellMarginLeft">margin-left:</label>
<input id="txtButtonCellMarginLeft" type="text" v-model="marginLeft" />
</div>
<div class="option-row">
<label for="txtButtonCellMarginTop">margin-top:</label>
<input id="txtButtonCellMarginTop" type="text" v-model="marginTop" />
</div>
<div class="option-row">
<label for="txtButtonCellMarginRight">margin-right:</label>
<input id="txtButtonCellMarginRight" type="text" v-model="marginRight" />
</div>
<div class="option-row">
<label for="txtButtonCellMarginBottom">margin-bottom:</label>
<input id="txtButtonCellMarginBottom" type="text" v-model="marginBottom" />
</div>
<div class="option-row">
<label for="txtButtonCellText">text:</label>
<input id="txtButtonCellText" type="text" v-model="text" />
</div>
<div class="option-row">
<label for="txtButtonCellBackColor">backColor:</label>
<input id="txtButtonCellBackColor" type="text" v-model="buttonBackColor" />
</div>
<div class="option-row">
<input type="button" id="setProperty" value="Update Properties" :disabled="disabled"
@click="updateProperty($event, true)" />
</div>
</div>
</div>
</template>
<script setup>
import '@mescius/spread-sheets-vue'
import { ref, computed } from 'vue';
import GC from '@mescius/spread-sheets';
import { getData } from "./data.js";
const spreadNS = GC.Spread.Sheets;
const marginLeft = ref(0);
const marginRight = ref(0);
const marginTop = ref(0);
const marginBottom = ref(0);
const text = ref('');
const buttonBackColor = ref('');
const disabled = ref(false);
let sheet = null;
const initSpread = (spread) => {
sheet = spread.getSheet(0);
sheet.suspendPaint();
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
const b0 = new spreadNS.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, spreadNS.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
sheet.resumePaint();
sheet.bind(spreadNS.Events.SelectionChanged, () => {
updateProperty(null, false);
});
};
const updateProperty = (e, isSet) => {
if (sheet) {
const sels = sheet.getSelections();
if (sels && sels.length > 0) {
const sel = getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
const buttonCellType = sheet.getCellType(sel.row, sel.col);
if (!(buttonCellType instanceof spreadNS.CellTypes.Button)) {
disabled.value = true;
return;
}
if (!isSet) {
disabled.value = false;
marginLeft.value = buttonCellType.marginLeft();
marginRight.value = buttonCellType.marginRight();
marginTop.value = buttonCellType.marginTop();
marginBottom.value = buttonCellType.marginBottom();
text.value = buttonCellType.text();
buttonBackColor.value = buttonCellType.buttonBackColor();
} else {
buttonCellType.marginLeft(parseInt(marginLeft.value));
buttonCellType.marginTop(parseInt(marginTop.value));
buttonCellType.marginRight(parseInt(marginRight.value));
buttonCellType.marginBottom(parseInt(marginBottom.value));
buttonCellType.text(text.value);
buttonCellType.buttonBackColor(buttonBackColor.value);
}
}
sheet.repaint();
}
};
const getActualRange = (range, maxRowCount, maxColCount) => {
const row = range.row < 0 ? 0 : range.row;
const col = range.col < 0 ? 0 : range.col;
const rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
const colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
};
</script>
<style scoped>
#app {
height: 100%;
}
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.sample-options {
z-index: 1000;
}
.option {
padding-bottom: 6px;
}
.checkbox {
padding-right: 12px;
display: inline-block;
}
label {
display: inline-block;
min-width: 100px;
}
input,
select {
width: 100%;
padding: 4px 0;
margin-top: 4px;
box-sizing: border-box;
}
input[type=checkbox] {
width: auto;
padding: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
</style>
<!DOCTYPE html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta http-equiv="X-UA-Compatible" content="IE=edge" />
<title>SpreadJS VUE</title>
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css"
href="$DEMOROOT$/en/vue3/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<script src="$DEMOROOT$/en/vue3/node_modules/systemjs/dist/system.src.js"></script>
<script src="./systemjs.config.js"></script>
<script src="./compiler.js" type="module"></script>
<script>
var System = SystemJS;
System.import("./src/app.js");
System.import('$DEMOROOT$/en/lib/vue3/license.js');
</script>
</head>
<body>
<div id="app"></div>
</body>
</html>
export function getData() {
return [
{ name: "Stoves S0", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Computers C1", line: "Washers", color: "Green", discontinued: true, rating: "Average" },
{ name: "Washers W3", line: "Washers", color: "Green", discontinued: true, rating: "Average" }
]
}
(function (global) {
SystemJS.config({
transpiler: 'plugin-babel',
babelOptions: {
es2015: true
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
packageConfigPaths: [
'./node_modules/*/package.json',
"./node_modules/@mescius/*/package.json",
"./node_modules/@babel/*/package.json",
"./node_modules/@vue/*/package.json"
],
map: {
'vue': "npm:vue/dist/vue.esm-browser.js",
'tiny-emitter': 'npm:tiny-emitter/index.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
"systemjs-babel-build": "npm:systemjs-plugin-babel/systemjs-babel-browser.js",
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-resources-en': 'cdn:@mescius/spread-sheets-resources-en/index.js',
'@mescius/spread-sheets-vue': 'cdn:@mescius/spread-sheets-vue/index.js'
},
meta: {
'*.css': { loader: 'systemjs-plugin-css' },
'*.vue': { loader: "../plugin-vue/index.js" }
}
});
})(this);

To create a button cell, follow this example:
You can customize your Button using the many provided APIs. If you want to control the button's position in the cell, use the following methods.
marginTop: Gets or sets the button's top margin in pixels relative to the cell.
marginRight: Gets or sets the button's right margin in pixels relative to the cell.
marginBottom: Gets or sets the button's bottom margin in pixels relative to the cell.
marginLeft: Gets or sets the button's left margin in pixels relative to the cell.
You can use the text method to get and set the button's content. Use the buttonBackColor method to get and set the button's background color. For example:
import { Component, NgModule, enableProdMode } from '@angular/core';
import { BrowserModule } from '@angular/platform-browser';
import { FormsModule } from '@angular/forms';
import { platformBrowserDynamic } from '@angular/platform-browser-dynamic';
import { SpreadSheetsModule } from '@mescius/spread-sheets-angular';
import GC from '@mescius/spread-sheets';
import './styles.css';
const spreadNS = GC.Spread.Sheets;
@Component({
selector: 'app-component',
templateUrl: 'src/app.component.html'
})
export class AppComponent {
hostStyle = {
width: 'calc(100% - 280px)',
height: '100%',
overflow: 'hidden',
float: 'left'
};
marginLeft = 0;
marginRight = 0;
marginTop = 0;
marginBottom = 0;
text = '';
buttonBackColor = '';
disabled = false;
sheet: GC.Spread.Sheets.Worksheet;
initSpread($event: any) {
const sheet = $event.spread.getSheet(0);
this.sheet = sheet;
sheet.suspendPaint();
sheet.setColumnWidth(2, 120);
sheet.setColumnWidth(1, 120);
sheet.setRowHeight(1, 50);
var b0 = new spreadNS.CellTypes.Button();
b0.text("Margin");
b0.marginLeft(15);
b0.marginTop(7);
b0.marginRight(15);
b0.marginBottom(7);
sheet.setCellType(1, 2, b0, spreadNS.SheetArea.viewport);
sheet.setValue(1, 1, "ButtonCellType");
sheet.resumePaint();
sheet.bind(spreadNS.Events.SelectionChanged, () => {
this.updateProperty(null, false);
});
}
updateProperty(e: MouseEvent, isSet: boolean) {
const sheet = this.sheet;
const sels = sheet.getSelections();
if (sels && sels.length > 0) {
const sel = this.getActualRange(sels[0], sheet.getRowCount(), sheet.getColumnCount());
const buttonCellType = sheet.getCellType(sel.row, sel.col);
if (!(buttonCellType instanceof spreadNS.CellTypes.Button)) {
this.disabled = true;
return;
}
if (!isSet) {
this.disabled = false;
this.marginLeft = buttonCellType.marginLeft();
this.marginRight = buttonCellType.marginRight();
this.marginTop = buttonCellType.marginTop();
this.marginBottom = buttonCellType.marginBottom();
this.text = buttonCellType.text();
this.buttonBackColor = buttonCellType.buttonBackColor();
} else {
buttonCellType.marginLeft(Number(this.marginLeft));
buttonCellType.marginTop(Number(this.marginTop));
buttonCellType.marginRight(Number(this.marginRight));
buttonCellType.marginBottom(Number(this.marginBottom));
buttonCellType.text(this.text);
buttonCellType.buttonBackColor(this.buttonBackColor);
}
}
sheet.repaint();
}
getActualRange(range: GC.Spread.Sheets.Range, maxRowCount: number, maxColCount: number) {
const row = range.row < 0 ? 0 : range.row;
const col = range.col < 0 ? 0 : range.col;
const rowCount = range.rowCount < 0 ? maxRowCount : range.rowCount;
const colCount = range.colCount < 0 ? maxColCount : range.colCount;
return new spreadNS.Range(row, col, rowCount, colCount);
}
}
@NgModule({
imports: [BrowserModule, SpreadSheetsModule, FormsModule],
declarations: [AppComponent],
exports: [AppComponent],
bootstrap: [AppComponent]
})
export class AppModule { }
enableProdMode();
// Bootstrap application with hash style navigation and global services.
platformBrowserDynamic().bootstrapModule(AppModule);
<!doctype html>
<html style="height:100%;font-size:14px;">
<head>
<meta charset="utf-8" />
<meta name="viewport" content="width=device-width, initial-scale=1.0" />
<link rel="stylesheet" type="text/css" href="$DEMOROOT$/en/angular/node_modules/@mescius/spread-sheets/styles/gc.spread.sheets.excel2013white.css">
<!-- Polyfills -->
<script src="$DEMOROOT$/en/angular/node_modules/zone.js/fesm2015/zone.min.js"></script>
<!-- SystemJS -->
<script src="$DEMOROOT$/en/angular/node_modules/systemjs/dist/system.js"></script>
<script src="systemjs.config.js"></script>
<script>
// workaround to load 'rxjs/operators' from the rxjs bundle
System.import('rxjs').then(function (m) {
System.import('@angular/compiler');
System.set(SystemJS.resolveSync('rxjs/operators'), System.newModule(m.operators));
System.import('$DEMOROOT$/en/lib/angular/license.ts');
System.import('./src/app.component');
});
</script>
</head>
<body>
<app-component></app-component>
</body>
</html>
<div class="sample-tutorial">
<gc-spread-sheets [hostStyle]="hostStyle" (workbookInitialized)="initSpread($event)">
<gc-worksheet></gc-worksheet>
</gc-spread-sheets>
<div class="options-container">
<label>Select the button cell in Spread and edit its options with these text boxes.</label>
<div class="option-row">
<label for="txtButtonCellMarginLeft">margin-left:</label>
<input id="txtButtonCellMarginLeft" [(ngModel)]="marginLeft"/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginTop">margin-top:</label>
<input id="txtButtonCellMarginTop" [(ngModel)]="marginTop"/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginRight">margin-right:</label>
<input id="txtButtonCellMarginRight" [(ngModel)]="marginRight"/>
</div>
<div class="option-row">
<label for="txtButtonCellMarginBottom">margin-bottom:</label>
<input id="txtButtonCellMarginBottom" [(ngModel)]="marginBottom"/>
</div>
<div class="option-row">
<label for="txtButtonCellText">text:</label>
<input id="txtButtonCellText" [(ngModel)]="text"/>
</div>
<div class="option-row">
<label for="txtButtonCellBackColor">backColor:</label>
<input id="txtButtonCellBackColor" [(ngModel)]="buttonBackColor"/>
</div>
<div class="option-row">
<input type="button" id="setProperty" value="Update Properties" [disabled]="disabled" (click)="updateProperty($event, true)" />
</div>
</div>
</div>
.sample-tutorial {
position: relative;
height: 100%;
overflow: hidden;
}
.sample-spreadsheets {
width: calc(100% - 280px);
height: 100%;
overflow: hidden;
float: left;
}
.options-container {
float: right;
width: 280px;
overflow: auto;
padding: 12px;
height: 100%;
box-sizing: border-box;
background: #fbfbfb;
}
.sample-options{
z-index: 1000;
}
.option {
padding-bottom: 6px;
}
.checkbox {
padding-right: 12px;
display: inline-block;
}
label {
display: inline-block;
min-width: 100px;
}
input, select {
width: 100%;
padding: 4px 0;
margin-top: 4px;
box-sizing: border-box;
}
input[type=checkbox] {
width: auto;
padding: 0;
}
body {
position: absolute;
top: 0;
bottom: 0;
left: 0;
right: 0;
}
(function (global) {
System.config({
transpiler: 'ts',
typescriptOptions: {
tsconfig: true
},
meta: {
'typescript': {
"exports": "ts"
},
'*.css': { loader: 'css' }
},
paths: {
// paths serve as alias
'npm:': 'node_modules/',
'cdn:': 'https://cdn.mescius.io/demoapps/packages/spreadjs/19.1.2-master-2026-06-10-2131/'
},
// map tells the System loader where to look for things
map: {
'zone': 'npm:zone.js/fesm2015/zone.min.js',
'rxjs': 'npm:rxjs/dist/bundles/rxjs.umd.min.js',
'@angular/core': 'npm:@angular/core/fesm2022',
'@angular/common': 'npm:@angular/common/fesm2022/common.mjs',
'@angular/compiler': 'npm:@angular/compiler/fesm2022/compiler.mjs',
'@angular/platform-browser': 'npm:@angular/platform-browser/fesm2022/platform-browser.mjs',
'@angular/platform-browser-dynamic': 'npm:@angular/platform-browser-dynamic/fesm2022/platform-browser-dynamic.mjs',
'@angular/common/http': 'npm:@angular/common/fesm2022/http.mjs',
'@angular/router': 'npm:@angular/router/fesm2022/router.mjs',
'@angular/forms': 'npm:@angular/forms/fesm2022/forms.mjs',
'jszip': 'npm:jszip/dist/jszip.min.js',
'typescript': 'npm:typescript/lib/typescript.js',
'ts': './plugin.js',
'tslib':'npm:tslib/tslib.js',
'css': 'npm:systemjs-plugin-css/css.js',
'plugin-babel': 'npm:systemjs-plugin-babel/plugin-babel.js',
'systemjs-babel-build':'npm:systemjs-plugin-babel/systemjs-babel-browser.js',
'@mescius/spread-sheets': 'cdn:@mescius/spread-sheets/index.js',
'@mescius/spread-sheets-angular': 'cdn:@mescius/spread-sheets-angular/fesm2020/mescius-spread-sheets-angular.mjs',
'@grapecity/jsob-test-dependency-package/react-components': 'npm:@grapecity/jsob-test-dependency-package/react-components/index.js'
},
// packages tells the System loader how to load when no filename and/or no extension
packages: {
src: {
defaultExtension: 'ts'
},
rxjs: {
defaultExtension: 'js'
},
"node_modules": {
defaultExtension: 'js'
},
"node_modules/@angular": {
defaultExtension: 'mjs'
},
"@mescius/spread-sheets-angular": {
defaultExtension: 'mjs'
},
'@angular/core': {
defaultExtension: 'mjs',
main: 'core.mjs'
}
}
});
})(this);